﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using Silanis.ESL.SDK.Internal;
using System.Diagnostics;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json;

namespace completionReport
{
    class completionReport
    {
        private static string API_KEY = "api_key";
        private static string API_URL = "https://sandbox.esignlive.com/api";
        public static EslClient eslClient = new EslClient(API_KEY, API_URL);

        public static void Main(string[] args)
        {

            // Date and time range to get completion/usage report.
            DateTime from = DateTime.Now.AddDays(-10);

            DateTime to = DateTime.Now;

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", API_KEY);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.GetAsync(new Uri(API_URL) + "/reports/completion?status=draft&from=2016-05-20&to=2016-06-08").Result;

            JObject obj = JObject.Parse(response.Content.ReadAsStringAsync().Result);

            foreach (var sender in obj["senders"])
            {
                Debug.WriteLine("Sender: " + sender["sender"]["email"] + " has " + sender["packages"].Count() + " packages in DRAFT");

                foreach (var package in sender["packages"])
                {
                    Debug.WriteLine(package["id"] + ", " + package["name"] + ", Sender: " + sender["sender"]["email"]);
                }
            }


        }
    }
}
